// -*- C -*-

fdia=1.75;

slop=0.5;
bigslop=slop*2;

exteffrad = 70;
hubeffrad = 30;
hubbigrad = 20;
hublwidth = 3;
hubstemwidth = 2;
hublthick = 10;
hubaxlelen = 25;
hubaxlerad = 5;
totalheightfromtower = 240;
axletowerfudgebend = 0;
axleaxlefudgebend = 3;
axlepadlen = 1.0;

prongthick=5;
prongwidth=5;
ratchetstep=15;
ratchettooth=3;
ratchettoothheight=5;
ratchettoothsmoothr=1;
ratchettoothslope=0.75;
overlap=0.5;
cupbigrad=20;

xstraightmul = 1.75;

propxshift = 0;

doveclipheight = 10;

teethh=3;
teethgapx=4+fdia;

prongstalkxwidth=3;

stalklength=35;
overclipcupgap=5;
overclipdepth=15;
overcliproundr=2.0;
overclipthick=0.5;

overclipsmaller=-2.5;
overclipbigger=0.0;

wingspoke=3;
wingsize=6;
wingthick=3;

armendwallthick=2.5;
armendbasethick=1.2;

axlehorizoffset = 12.5;
axlevertheight = 100;
towercliph = 16;
towerclipcount = 3;
towerpillarw = 5;

axlepinrad = 2;
axlepintabrad = 5;

washerthick = 1.2;
washerthinthick = 0.8;
washerverythinthick = 0.4;
washerrad = hubaxlerad + 7.5;
frictionwasherarmwidth = 3;
frictionwasherextrapush = 1.0;

ratchetpawl=ratchetstep-ratchettooth-bigslop*2;

include <doveclip.scad>
include <cliphook.scad>
include <filamentteeth.scad>
include <axlepin.scad>

channelwidth = prongthick + slop;
channeldepth = prongwidth + ratchettoothheight;
totalwidth = armendwallthick*2 + channelwidth;
totalheight = channeldepth + armendbasethick;
stalkwidth = prongwidth + prongstalkxwidth;

module ArmEnd(length=120){ ////toplevel
  translate([ratchettoothsmoothr, channelwidth/2, -armendbasethick]) {
    rotate([0,0,-90])
      DoveClipPairBase(h=doveclipheight);
  }

  difference(){
    translate([0, -armendwallthick, -armendbasethick])
      cube([length, totalwidth, totalheight]);
    translate([-1, 0, 0])
      cube([length+1 - ratchettooth, channelwidth, channeldepth+1]);
    translate([-1, 0, ratchettoothheight])
      cube([length+2, channelwidth, channeldepth+1]);
  }
  for (dx = [0 : ratchetstep : length - ratchetstep]) translate([dx,0,0]) {
    translate([ratchettoothsmoothr+0.5, armendwallthick/2, 0]) minkowski(){
      rotate([90,0,0])
	cylinder($fn=20, r=ratchettoothsmoothr, h=armendwallthick);
      multmatrix([	[	1, 0, ratchettoothslope, 0	],
			[	0,	1,	0,	0	],
			[	0,	0,	1,	0	],
			[	0,	0,	0,	1	]])
	cube([ratchettooth - ratchettoothsmoothr*2,
	      channelwidth, ratchettoothheight - ratchettoothsmoothr]);
    }
  }
}

module FilamentCupHandle(){
  pawlusewidth = ratchetpawl-ratchettoothsmoothr*2;
  mirror([0,1,0]) {
    cube([stalklength, stalkwidth, prongthick]);
    translate([stalklength, stalkwidth/2, 0])
      cylinder(r=stalkwidth/2, h=prongthick, $fn=20);
    translate([ratchettoothsmoothr, stalkwidth, 0]) {
      minkowski(){
	cylinder($fn=20,r=ratchettoothsmoothr, h=1);
	multmatrix([	[	1, -ratchettoothslope, 0, 0	],
			[	0,	1,	0,	0	],
			[	0,	0,	1,	0	],
			[	0,	0,	0,	1	]])
	  cube([pawlusewidth,
		ratchettoothheight - ratchettoothsmoothr,
		prongthick - 1]);
      }
    }
  }
}

module FilamentCupCup(){
  xstraight = cupbigrad * xstraightmul;
  linear_extrude(height=prongthick) {
    FlatArc(0,0, cupbigrad,cupbigrad+prongwidth, 89,271, $fn=80);
  }
  for (my=[0,1]) mirror([0,my,0]) {
    translate([0,cupbigrad,0])
      cube([xstraight, prongwidth, prongthick]);
  }
}

module FilamentCup() { ////toplevel
  FilamentCupHandle();

  dx = cupbigrad + prongwidth;
  gapy = prongwidth;
  dy = cupbigrad + gapy + overclipcupgap;

  translate([dx, dy, 0])
    FilamentCupCup();
  translate([0, -1, 0]);
  cube([prongwidth, dy+1, prongthick]);

  midrad = cupbigrad + prongwidth/2;

  propshift = stalklength - overclipdepth - prongthick + propxshift;
  proptaken = propshift;
  echo(cupbigrad, dx, midrad, propshift, proptaken);

  translate([propshift, -1, 0]) {
    // something is wrong with the y calculation
    cube([prongwidth,
	  dy - sqrt(midrad*midrad - proptaken*proptaken) - prongwidth/2,
	  prongthick]);
  }
  translate([0, overclipcupgap, 0])
    rotate([0,0, 102 + fdia])
    FilamentTeeth(fdia=fdia, h=teethh);
}

module CupSecuringClipSolid(w,d,h1,h2){
  rotate([0,-90,0]) translate([0,-h1/2,-w/2]) linear_extrude(height=w) {
    polygon(points=[[0,0], [d,0], [d,h2], [0,h1]]);
  }
}

module CupSecuringClipSolidSmooth(xrad=0, xdepth=0){
  hbase = totalheight + prongstalkxwidth - overcliproundr*2;
  minkowski(){
    CupSecuringClipSolid(w=totalwidth,
			 d=overclipdepth + xdepth,
			 h1=hbase - overclipsmaller,
			 h2=hbase + overclipbigger);
    cylinder($fn=20, h=0.01, r=overcliproundr+xrad);
  }
}

module CupSecuringClip(){ ////toplevel
  wingswidth = wingspoke*2 + overclipthick*2 + overcliproundr*2 + totalwidth;
  difference(){
    union(){
      CupSecuringClipSolidSmooth(xrad=overclipthick, xdepth=0);
      translate([-wingswidth/2, -wingsize/2, 0])
	cube([wingswidth, wingsize, wingthick]);
    }
    translate([0,0,-0.1])
      CupSecuringClipSolidSmooth(xrad=0, xdepth=0.2);
  }
}

module ArmDoveClipPin(){ ////toplevel
  DoveClipPin(h=doveclipheight);
}

module TowerDoveClipPin(){ ////toplevel
  DoveClipPin(h=towercliph/2);
}

module Hub(){ ////toplevel
  difference(){
    cylinder($fn=60, h=hublthick, r=hubbigrad);
    translate([0,0,-1])
      cylinder($fn=30, h=hublthick+2, r=(hubbigrad-hublwidth));
  }
  axlerad = hubaxlerad + slop;
  difference(){
    cylinder(h=hubaxlelen, r=axlerad+hublwidth);
    translate([0,0,-1]) cylinder($fn=60, h=hubaxlelen+2, r=axlerad);
  }
  hole = hubeffrad - hubbigrad - DoveClip_depth() - hublwidth*2;
  holewidth = DoveClipPairSane_width() - hubstemwidth*2;
  for (ang=[0,120,240])
    rotate([0,0,ang]) {
      difference() {
	translate([hubeffrad,0,0])
	  DoveClipPairSane(h=doveclipheight,
			   baseextend = (hubeffrad - DoveClip_depth()
					 - hubbigrad + hublwidth));
	if (hole>hublwidth && holewidth > 2) {
	  translate([hubbigrad + hublwidth, -holewidth/2, -1])
	    cube([hole, holewidth, hublthick+2]);
	}
      }
    }
  xmin = axlerad+hublwidth/2;
  xmax = hubbigrad-hublwidth/2;
  for (ang = [0 : 60 : 359])
    rotate([0,0,ang]) rotate([90,0,0]) {
      translate([0,0,-hublwidth/2])
	linear_extrude(height=hublwidth)
	polygon([[xmin,0.05], [xmax,0.05],
		 [xmax,hublthick-0.2], [xmin, hubaxlelen-0.2]]);
    }
}

module ArmExtender(){ ////toplevel
  DoveClipExtender(length=exteffrad-hubeffrad,
		   ha=doveclipheight,
		   hb=doveclipheight);
}

module FsAxlePin(){ ////toplevel
  AxlePin(hubaxlerad, washerrad*2, axlepinrad, axlepintabrad, slop);
}

module Axle(){ ////toplevel
  pillarswidth = DoveClipPairSane_width(towerclipcount);

  rotate([0,0, -( axleaxlefudgebend + atan(slop/hubaxlelen) ) ])
  translate([-axlehorizoffset, -axlevertheight, 0]) {
    rotate([0,0,-axletowerfudgebend])
    rotate([0,0,-90])
      DoveClipPairSane(h=towercliph, count=towerclipcount, baseextend=3);
    translate([0, DoveClip_depth(), 0])
    rotate([0,0,90])
      ExtenderPillars(axlevertheight - DoveClip_depth(),
		      pillarswidth, towercliph,
		      pillarw=towerpillarw);
  }

  axleclearlen = hubaxlelen + slop*4 + washerthick*2 + axlepadlen;
  axlerad = hubaxlerad-slop;
  bump = axlerad * 0.2;
  shift = axlerad-bump;
  joinbelowallow = 3;

  intersection(){
    translate([0, 0, shift]) {
      difference() {
	union(){
	  translate([-1, 0, 0])
	    rotate([0,90,0])
	    cylinder($fn=60,
		     r = axlerad,
		     h = 1 + axleclearlen + axlepinrad*2 + 2);
	  mirror([1,0,0]) rotate([0,90,0])
	    cylinder(r = axlerad*1.75, h = 3);
	  intersection(){
	    mirror([1,0,0])
	      translate([axlehorizoffset - pillarswidth/2, 0, 0])
	      rotate([0,90,0])
	      cylinder($fn=60,
		       r = towercliph - shift,
		       h = pillarswidth);
	    translate([-50, -joinbelowallow, -50])
	      cube([100, joinbelowallow+50, 100]);
	  }
	}
	rotate([90,0,0])
	translate([axleclearlen + axlepinrad/2, 0, -25])
	  cylinder(r = axlepinrad + slop, h=50);
      }
    }
    translate([-50,-50,0]) cube([100,100,100]);
  }
}

module washer(thick){
  Washer(hubaxlerad, washerrad, thick, slop);
}

module AxleWasher(){ ////toplevel
  washer(thick=washerthick);
}

module AxleThinWasher(){ ////toplevel
  washer(thick=washerthinthick);
}

module AxleVeryThinWasher(){ ////toplevel
  washer(thick=washerverythinthick);
}

module AxleFrictionWasher(){ ////toplevel
  difference(){
    cylinder(h=washerthick, r=washerrad);
    translate([0,0,-1]) cylinder(h=washerthick+2, r=hubaxlerad+slop);
  }
  frarmr = hubbigrad;
  frarmw = frictionwasherarmwidth;
  frarmpawlr = hublwidth;
  frarmpawlpush = slop*4 + frictionwasherextrapush;
  for (ang=[0,180]) rotate([0,0,ang]) {
    translate([washerrad-1, -frarmw/2, 0])
      cube([frarmr - washerrad + 1, frarmw, washerthick]);
    intersection(){
      translate([frarmr - frarmpawlr, -50, 0])
	cube([frarmpawlr, 100, 50]);
      rotate([0,90,0])
	cylinder(h = 50, r = frarmpawlpush, $fn=36);
    }
  }
}

module TowerExtender(){ ////toplevel
  l = totalheightfromtower - axlevertheight;
  echo("TowerExtender",l);
  DoveClipExtender(length = l,
		   ha = towercliph, hb = towercliph,
		   counta = towerclipcount, countb = towerclipcount,
		   pillarw = towerpillarw);
}

//ArmEnd();
//FilamentCup();
//CupSecuringClip();
//Hub();
//ArmExtender();
//Axle();
//AxleWasher();
//AxlePin();
//AxleFrictionWasher();
